
From: Tommy Christensen <tommy.christensen@tpack.net>

But as stated in bonding.txt, the ARP monitor requires the underlying
driver to update dev->trans_start and dev->last_rx.

The patch below adds the required functionality to the TUN/TAP driver.
Please test if this helps in your case.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/drivers/net/tun.c |    2 ++
 1 files changed, 2 insertions(+)

diff -puN drivers/net/tun.c~tun-tan-arp-monitor-support drivers/net/tun.c
--- 25/drivers/net/tun.c~tun-tan-arp-monitor-support	Wed Jan 12 14:56:05 2005
+++ 25-akpm/drivers/net/tun.c	Wed Jan 12 14:56:05 2005
@@ -92,6 +92,7 @@ static int tun_net_xmit(struct sk_buff *
 			goto drop;
 	}
 	skb_queue_tail(&tun->readq, skb);
+	dev->trans_start = jiffies;
 
 	/* Notify and wake up reader process */
 	if (tun->flags & TUN_FASYNC)
@@ -240,6 +241,7 @@ static __inline__ ssize_t tun_get_user(s
 		skb->ip_summed = CHECKSUM_UNNECESSARY;
  
 	netif_rx_ni(skb);
+	tun->dev->last_rx = jiffies;
    
 	tun->stats.rx_packets++;
 	tun->stats.rx_bytes += len;
_
